<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="employee-list">
  <template>
    <style>
      :host {
        display: block;
      }
    </style>
    <div>Employee list: </div>
    <dom-repeat items="{{employees}}" filter="isEngineer">
      <template>
        <div>First name: <span>{{item.first}}</span></div>
        <div>Last name: <span>{{item.last}}</span></div>
      </template>
    </dom-repeat>
  </template>

  <script>
    /**
     * `employee-list`
     * 
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class EmployeeList extends Polymer.Element {
      static get is() { return 'employee-list'; }
      static get properties() {
        return {
          employees: {
            value() {
              return [
                {first: 'Bob', last: 'Smith', type: "engineer", manager: {type: "CEO"}},
                {first: 'Sally', last: 'Johnson', type: "doctor", manager: {type: "millionary"}},
                {first: 'Bitterson', last: 'Mark', type: "politician", manager: {type: "psycologist"}},
                {first: 'Attlestan', last: 'Boñeri', type: "police_officer", manager: {type: "engineer"}}
              ];
            }
          }
        };
      }
      isEngineer(item){
        return item.type == 'engineer' || item.manager.type == 'engineer';
      }
    }

    window.customElements.define(EmployeeList.is, EmployeeList);
  </script>
</dom-module>
